static int sensor_msgm(char *nick, char *uhost, char *hand, char *chan, char *rest)
{
  int i;
  char buf[511];

  strncpy(buf, rest, 510);
  buf[510] = 0;
  rest = buf;
  if (hand[0] == '*')
    return 0;
  incrstats(hand, chan, T_WORDS, countwords(rest), 0);
  incrstats(hand, chan, T_LETTERS, strlen(rest), 0);
  incrstats(hand, chan, T_LINES, 1, 0);
  i = countsmileys(rest);
  if (i)
    incrstats(hand, chan, T_SMILEYS, i, 0);
  i = countquestions(rest);
  if (i)
    incrstats(hand, chan, T_QUESTIONS, i, 0);
  addquote(hand, chan, rest);
  calcwordstats(hand, chan, rest);
  return 0;
}

static void sensor_minutely()
{
  struct chanset_t *chan;
  memberlist *m;

  Context;
  for (chan = chanset; chan; chan = chan->next) {
    if (chan->channel.members > 0) {
      for (m = chan->channel.member; m; m = m->next) {
#ifndef OLDBOT
        if (m->user != NULL)
          incrstats(m->user->handle, chan->dname, T_MINUTES, 1, 0);
        else
          stats_autoadd(m, chan->dname);
#else
        if (m->user != NULL)
          incrstats(m->user->handle, chan->name, T_MINUTES, 1, 0);
        else
          stats_autoadd(m, chan->name);
#endif
      }
    }
  }
  Context;
}

static void sensor_countusers()
{
  struct chanset_t *chan;
  memberlist *m;
  globstats *gs;
  int hour, nr;

  for (chan = chanset; chan; chan = chan->next) {
    if (chan->channel.members < 1)
      continue;
    nr = 0;
#if EGG_IS_MIN_VER(10500)
    gs = findglobstats(chan->dname);
#else
    gs = findglobstats(chan->name);
#endif
    if (!gs)
      continue;
    for (m = chan->channel.member; m; m = m->next) {
      if (!m->nick[0])
        continue;
      if (m->user != NULL)
#if EGG_IS_MIN_VER(10500)
        if (matchattr(m->user, nostats, chan->dname))
#else
        if (matchattr(m->user, nostats, chan->name))
#endif
          continue;
      nr++;
    }
    hour = gethour();
    if (hour != lasthour) {
      gs->users[S_USERSUM][hour] = nr;
      gs->users[S_USERCOUNTS][hour] = 1;
      lasthour = hour;
    } else {
      gs->users[S_USERSUM][hour] += nr;
      if (gs->users[S_USERCOUNTS][hour] < 0)
        gs->users[S_USERCOUNTS][hour] = 1;
      else
        gs->users[S_USERCOUNTS][hour]++;
    }
  }
}

static void sensor_peak(char *channel)
{
  struct chanset_t *chan;
  memberlist *m;
  globstats *gs;
  int users = 0;

  gs = findglobstats(channel);
  if (!gs)
    return;
#ifndef OLDBOT
  chan = findchan_by_dname(channel);
#else
  chan = findchan(channel);
#endif
  if (!chan)
    return;
  if (chan->channel.members > 0) {
    for (m = chan->channel.member; m; m = m->next) {
      if (!m->nick[0])
        continue;
      if (m->user) {
        if (matchattr(m->user, nopeak, channel))
          continue;
      }
      users++;
    }
  }
  if (users > gs->peak[S_TOTAL]) {
    gs->peak[S_TOTAL] = users;
    putlog(LOG_MISC, "*", "New user peak in %s: %d.", channel, users);
  }
  if (users > gs->peak[S_TODAY])
    gs->peak[S_TODAY] = users;
  if (users > gs->peak[S_WEEKLY])
    gs->peak[S_WEEKLY] = users;
  if (users > gs->peak[S_MONTHLY])
    gs->peak[S_MONTHLY] = users;

}

static int sensor_topc(char *nick, char *uhost, char *hand, char *chan, char *topic)
{
  Context;
  if (hand[0] == '*')
    return 0;
  addtopic(chan, topic, nick);
  incrstats(hand, chan, T_TOPICS, 1, 0);
  Context;
  return 0;
}

static int sensor_action(char *nick, char *uhost, char *hand, char *chan, char *key, char *rest)
{
  char buf[511], *pbuf;

  Context;
  buf[0] = 0;
  pbuf = buf;
  if (!strchr(CHANMETA, chan[0]))
    return 0;
  if (hand[0] == '*')
    return 0;
  if (strlen(nick) > 500)
    return 0;
  strcpy(pbuf, nick);
  pbuf[strlen(nick)] = ' ';
  strncpy(pbuf + strlen(nick) + 1, rest, 508 - strlen(nick));
  pbuf[510] = 0;
  incrstats(hand, chan, T_ACTIONS, 1, 0);
  sensor_msgm(nick, uhost, hand, chan, pbuf);
  return 0;
}

static int sensor_kick(char *nick, char *uhost, char *hand, char *chan, char *victim, char *reason)
{
  Context;
  if (hand[0] == '*')
    return 0;
  incrstats(hand, chan, T_KICKS, 1, 0);
  Context;
  return 0;
}

static int sensor_mode(char *nick, char *uhost, char *hand, char *chan, char *mode, char *victim)
{
  Context;
  if (hand[0] == '*')
    return 0;
  incrstats(hand, chan, T_MODES, 1, 0);
  if ((mode[1] == 'b') && (mode[0] == '+'))
    incrstats(hand, chan, T_BANS, 1, 0);
  Context;
  return 0;
}

static int sensor_nick(char *nick, char *uhost, char *hand, char *chan, char *newnick)
{
  if (hand[0] == '*')
    return 0;
  incrstats(hand, chan, T_NICKS, 1, 0);
  return 0;
}

static int sensor_join(char *nick, char *uhost, char *hand, char *chan)
{
  sensor_peak(chan);
  if (hand[0] == '*')
    return 0;
  incrstats(hand, chan, T_JOINS, 1, 0);
  addhost(uhost, findglobstats(chan));
  return 0;
}

static cmd_t stats_pubm[] =
{
  {"*", "", (Function) sensor_msgm, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_topc[] =
{
  {"*", "", (Function) sensor_topc, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_ctcp[] =
{
  {"ACTION", "", (Function) sensor_action, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_kick[] =
{
  {"*", "", (Function) sensor_kick, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_mode[] =
{
  {"*", "", (Function) sensor_mode, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_nick[] =
{
  {"*", "", (Function) sensor_nick, "stat"},
  {0, 0, 0, 0}
};

static cmd_t stats_join[] =
{
  {"*", "", (Function) sensor_join, "stat"},
  {0, 0, 0, 0}
};
